program dinamic_dek;
uses crt;
type link_type=^element_type;
     element_type=record value:integer;
                         link:link_type;
                         end;
procedure menu;
  begin
    writeln('1-dobavit v dek sprava');
    writeln('2-dobavit v dek sleva');
    writeln('3-izvlech sprava');
    writeln('4-izvlech sleva');
    writeln('5-ochistit dek');
    writeln('6-raspechatat dek');
    writeln('7-Bb|XOg');
  end;
procedure add(var root:pointer; user:boolean; new_value:integer; var f:text; orient:string);
var element:link_type;
  begin
    if (root<>nil)
    then
      begin
        if (orient='right')
        then
          begin
            element:=root;
            while (element^.link<>nil) do
              begin
                element:=element^.link;
              end;
            new(element^.link);
            element:=element^.link;
            element^.link:=nil;
            element^.value:=new_value;
          end
        else
          begin
            new(element);
            element^.value:=new_value;
            element^.link:=root;
            root:=element;
          end;
      end
        else
          begin
            new(element);
            root:=element;
            element^.link:=nil;
            element^.value:=new_value;
          end;
    if (not user)
    then
      begin
        writeln(f,'ok');
      end;
  end;
procedure delete_element(var root:pointer; user:boolean; var f:text; orient:string);
var element,prev_element:link_type;
  begin
    if (root<>nil)
    then
      begin
        if (orient='left')
        then
          begin
            element:=root;
            if (user)
            then
              writeln('element: ',element^.value)
            else
              writeln(f,'ok ',element^.value);
            root:=element^.link;
            dispose(element);
          end
        else
          begin
            element:=root;
            prev_element:=nil;
            while (element^.link<>nil) do
              begin
                prev_element:=element;
                element:=element^.link;
              end;
            if (user)
            then
              writeln('element: ',element^.value)
            else
              writeln(f,'ok ',element^.value);
            dispose(element);
            if (prev_element<>nil)
            then
              prev_element^.link:=nil;
          end;
      end
    else
      begin
        if (user)
        then
          begin
            writeln('dek uje pust. Press enter.');
            readln;
          end
        else
          begin
            writeln(f,'empty');
          end;
      end;
  end;
procedure clear_dek(var root:pointer; user:boolean; var f:text);
var element,prev_link:link_type;
  begin
    element:=root;
    while (element<>nil) do
      begin
        prev_link:=element^.link;
        dispose(element);
        element:=prev_link;
      end;
    root:=nil;
    if (not user)
    then
      begin
        writeln(f,'ok');
      end;
  end;
procedure print(root:pointer; user:boolean; var f:text);
var element:link_type;
  begin
    if (root=nil)
    then
      begin
        if (user)
        then
          begin
            writeln('dek pust. press enter');
            readln;
          end
        else
          begin
            writeln(f,'');
          end;
      end
    else
      begin
        if (user)
        then
          begin
            element:=root;
            while (element<>nil) do
              begin
                write(element^.value,' ');
                element:=element^.link;
              end;
            writeln;
            writeln('press enter');
            readln;
          end
        else
          begin
            element:=root;
            while (element<>nil) do
              begin
                write(f,element^.value,' ');
                element:=element^.link;
              end;
            writeln(f);
          end;
      end
  end;
procedure user_interface(root:pointer);
var action_code,new_value:integer;
    user:boolean;
    var f:text;
  begin
    user:=TRUE;
    repeat
      clrscr;
      menu;
      writeln('action code:');
      readln(action_code);
      case action_code of
      1:begin
          write('value=');
          readln(new_value);
          add(root,user,new_value,f,'right');
        end;
      2:begin
          write('value=');
          readln(new_value);
          add(root,user,new_value,f,'left');
        end;
      3:delete_element(root,user,f,'right');
      4:delete_element(root,user,f,'left');
      5:clear_dek(root,user,f);
      6:print(root,user,f);
      end;
    until (action_code=7);
  end;
procedure file_interface(root:pointer; read_file,write_file:string);
var user:boolean;
    p,parametr:integer;
    f,f2:text;
    s,action,parametr_string:string;
  begin
    user:=FALSE;
    assign(f2,read_file);
    reset(f2);
    assign(f,write_file);
    rewrite(f);
    while (not eof(f2)) do
      begin
        readln(f2,s);
        p:=pos(' ',s);
        action:=copy(s,1,p-1);
        if (p=0)
        then
          begin
            action:=s;
          end;
        parametr_string:=copy(s,p+1,length(s)-p);
        val(parametr_string,parametr,p);
        if (action='rpush')
        then
          begin
            add(root,user,parametr,f,'right');
          end;
        if (action='lpush')
        then
          begin
            add(root,user,parametr,f,'left');
          end;
        if (action='rpop')
        then
          begin
            delete_element(root,user,f,'right');
          end;
        if (action='lpop')
        then
          begin
            delete_element(root,user,f,'left');
          end;
        if (action='clear')
        then
          begin
            clear_dek(root,user,f);
          end;
        if (action='print')
        then
          begin
            print(root,user,f);
          end;
      end;
    close(f2);
    close(f);
  end;
var read_file,write_file:string;
    root:pointer;
begin
  root:=nil;
  if (paramstr(1)<>''){᫨  ࠬ  ப}
  then{}
    begin
      read_file:=paramstr(1);{뢠 䠩 -  ࠬ}
      write_file:=paramstr(2);{室 䠩 - ன ࠬ}
      file_interface(root,read_file,write_file);
    end
  else{᫨ , }
    begin
      user_interface(root);
    end;
end.